commit 1e86448cd1615dc51f29a19fa6ed64f5e790d0f5
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Thu May 9 13:43:22 2024 +0530

    PS-9174 Issue in mysqldump (mysql dump utility)
    
    https://perconadev.atlassian.net/browse/PS-9174
    
    Bug#36248967:
       mysql/mysql-server@f351ea92a5a
       mysql/mysql-server@c334b7e5f02
    
    Problem: mysqldump not sanitizing the version string obtained from
    server which may lead to injecting malicious commands to the output.
    
    Fix: added function sanitizing the version string by cutting off
    illegal part and issuing warning.
    
    Test: check the server version in the output with and without injected
    payload.
    
    Change-Id: I1f19e1c90bdb8d444285e427092face3bb16da01

diff --git a/client/mysqldump.c b/client/mysqldump.c
index 8cb83f70b45..d143c951d2d 100644
--- a/client/mysqldump.c
+++ b/client/mysqldump.c
@@ -1,5 +1,5 @@
 /*
-   Copyright (c) 2000, 2023, Oracle and/or its affiliates.
+   Copyright (c) 2000, 2024, Oracle and/or its affiliates.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2.0,
@@ -762,6 +762,39 @@ static void short_usage(void)
   printf("For more options, use %s --help\n", my_progname);
 }
 
+static void get_safe_server_info(char *safe_server_info,
+                                 size_t safe_server_info_len) {
+  const char *server_info = mysql_get_server_info(&mysql_connection);
+  size_t i;
+  if (server_info == NULL) {
+    safe_server_info[0] = 0;
+    return;
+  }
+  DBUG_EXECUTE_IF("server_version_injection_test",
+  {
+    const char *payload= "5.7.0-injection_test\n\\! touch /tmp/xxx";
+    server_info= payload;
+  });
+  for (i = 0; i < safe_server_info_len; ++i) {
+    // End of string.
+    if (server_info[i] == 0)
+    {
+      safe_server_info[i]= 0;
+      return;
+    }
+    // Version may include only alphanumeric and punctuation characters.
+    // Cut off the rest of the string if incorrect character found.
+    if (!(my_isalnum(charset_info, server_info[i]) || my_ispunct(charset_info, server_info[i])))
+    {
+      safe_server_info[i] = 0;
+      fprintf(stderr,
+              "-- Warning: version string returned by server is incorrect.\n");
+      return;
+    }
+    safe_server_info[i]= server_info[i];
+  }
+  safe_server_info[safe_server_info_len - 1] = 0;
+}
 
 static void write_header(FILE *sql_file, char *db_name)
 {
@@ -782,6 +815,8 @@ static void write_header(FILE *sql_file, char *db_name)
   {
     my_bool freemem= FALSE;
     char const* text= fix_identifier_with_newline(db_name, &freemem);
+    char safe_server_info[SERVER_VERSION_LENGTH];
+    get_safe_server_info(safe_server_info, SERVER_VERSION_LENGTH);
 
     print_comment(sql_file, 0,
                   "-- MySQL dump %s  Distrib %s, for %s (%s)\n--\n",
@@ -797,8 +832,7 @@ static void write_header(FILE *sql_file, char *db_name)
     print_comment(sql_file, 0,
                   "-- ------------------------------------------------------\n"
                  );
-    print_comment(sql_file, 0, "-- Server version\t%s\n",
-                  mysql_get_server_info(&mysql_connection));
+    print_comment(sql_file, 0, "-- Server version\t%s\n", safe_server_info);
 
     if (opt_set_charset)
       fprintf(sql_file,
diff --git a/mysql-test/r/mysqldump_debug_bugs.result b/mysql-test/r/mysqldump_debug_bugs.result
new file mode 100644
index 00000000000..872bc0e8d37
--- /dev/null
+++ b/mysql-test/r/mysqldump_debug_bugs.result
@@ -0,0 +1,14 @@
+#
+# Bug#36248967: Security issue in mysqldump (mysql dump utility)
+#
+CREATE DATABASE test_bug36248967;
+-- Run mysqldump with payload injected to server version.
+A warning must be issued.
+-- Warning: version string returned by server is incorrect.
+The test version must be found:
+Pattern found.
+The test injected string must not be found:
+Pattern not found.
+-- Run mysqldump with correct server version.
+A warning must not be issued.
+DROP DATABASE test_bug36248967;
diff --git a/mysql-test/t/mysqldump_debug_bugs.test b/mysql-test/t/mysqldump_debug_bugs.test
new file mode 100644
index 00000000000..7bfca08978a
--- /dev/null
+++ b/mysql-test/t/mysqldump_debug_bugs.test
@@ -0,0 +1,30 @@
+--source include/mysql_have_debug.inc
+
+--echo #
+--echo # Bug#36248967: Security issue in mysqldump (mysql dump utility)
+--echo #
+
+let $grep_file=$MYSQLTEST_VARDIR/tmp/bug36248967.sql;
+let $grep_output=boolean;
+
+CREATE DATABASE test_bug36248967;
+
+--echo -- Run mysqldump with payload injected to server version.
+--echo A warning must be issued.
+--exec $MYSQL_DUMP --debug="d,server_version_injection_test" --result-file=$grep_file test_bug36248967 2>&1
+
+--echo The test version must be found:
+let $grep_pattern=5.7.0-injection_test;
+--source include/grep_pattern.inc
+
+--echo The test injected string must not be found:
+let $grep_pattern=\\! touch /tmp/xxx;
+--source include/grep_pattern.inc
+
+--echo -- Run mysqldump with correct server version.
+--exec $MYSQL_DUMP --result-file=$grep_file test_bug36248967 2>&1
+--echo A warning must not be issued.
+
+#Cleanup
+--remove_file $grep_file
+DROP DATABASE test_bug36248967;

